//+------------------------------------------------------------------+
//|                                                   ADXcrosses.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int timeFrame=0;
extern int ADXcrossesPeriod = 14;
extern bool ArrowsOnFirstBar = true;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
double b4plusdi, b4minusdi, nowplusdi, nowminusdi;
int    nShift;   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    SetIndexStyle(0, DRAW_ARROW);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, ExtMapBuffer1);
//----
    SetIndexStyle(1, DRAW_ARROW);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, ExtMapBuffer2);
//---- name for DataWindow and indicator subwindow label
    IndicatorShortName("ADXcrosses(" + ADXcrossesPeriod + ")");
    SetIndexLabel(0, "ADXcrUp");
    SetIndexLabel(1, "ADXcrDn"); 
    
//----
    switch(Period())
      {
        case     1: nShift = 1;   break;    
        case     5: nShift = 3;   break; 
        case    15: nShift = 5;   break; 
        case    30: nShift = 10;  break; 
        case    60: nShift = 15;  break; 
        case   240: nShift = 20;  break; 
        case  1440: nShift = 80;  break; 
        case 10080: nShift = 100; break; 
        case 43200: nShift = 200; break;               
      }
      timeFrame=MathMax(timeFrame,Period());
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*timeFrame/Period()),Bars-1);

   int shift = -1; if (ArrowsOnFirstBar) shift=1;
   for(int i = limit; i>=0; i--)
   {
         ExtMapBuffer1[i] = EMPTY_VALUE;
         ExtMapBuffer2[i] = EMPTY_VALUE;
            int y = iBarShift(NULL,timeFrame,Time[i]);
            int x = iBarShift(NULL,timeFrame,Time[i+shift]);
            if (x!=y)
            {
               b4plusdi   = iADX(NULL, timeFrame, ADXcrossesPeriod, PRICE_CLOSE, MODE_PLUSDI,  y+1);
               nowplusdi  = iADX(NULL, timeFrame, ADXcrossesPeriod, PRICE_CLOSE, MODE_PLUSDI,  y);
               b4minusdi  = iADX(NULL, timeFrame, ADXcrossesPeriod, PRICE_CLOSE, MODE_MINUSDI, y+1);
               nowminusdi = iADX(NULL, timeFrame, ADXcrossesPeriod, PRICE_CLOSE, MODE_MINUSDI, y);  
               
               if(b4plusdi < b4minusdi && nowplusdi > nowminusdi) ExtMapBuffer1[i] = Low[i]  - nShift*Point;
               if(b4plusdi > b4minusdi && nowplusdi < nowminusdi) ExtMapBuffer2[i] = High[i] + nShift*Point;
            }
    }
    return(0);
}

